include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext MonoPattern, ColorPattern
ext VVram_

Top equ 0

GDC equ 100h
WDC equ 110h
VDC2 equ 120h
VDC1 equ 130h

CharSize equ CharHeight*PlaneCount*2

dseg
Backup:
	defs VVramWidth*VVramHeight
color:
	defb 0
CharRam:
    defs 2*CharHeight*PlaneCount*Char_End


cseg
InitVram: public InitVram
    ; mov bx,80*8*10/2
    ; mov dx,WDC
    ; mov al,1
    ; out dx,al
    ; mov dx,WDC+2
    ; mov al,bl | out dx,al
    ; mov al,bh | out dx,al

    mov dx,VDC2
    xor al,al
    out dx,al
    ; mov dx,VDC1
    ; mov al,04h
    ; out dx,al

	mov di,CharRam+CharSize*Char_Ascii
	mov si,MonoPattern+CharHeight*Char_Ascii
	mov cx,(7 shl 8) or (Char_Wall-Char_Ascii)
	call MakePatternMono

    mov di,CharRam+CharSize*Char_Wall
	mov si,MonoPattern+CharHeight*Char_Wall
	mov cx,(5 shl 8) or (Char_Knife-Char_Wall)
	call MakePatternMono

    mov di,CharRam+CharSize*Char_Knife
	mov si,ColorPattern
	mov cl,Char_End-Char_Knife
	call MakePatternColor
ret

DoubleBits:
	push cx
		xor dx,dx
		mov ch,8
		do
			shl dx | shl dx
			shr al,1
			if b
				or dx,0003h
			endif
			dec ch
		while ne | wend
	pop cx
ret

MakePatternMono:
	mov [color],ch
	do
		mov ch,CharHeight
		do
			push cx
				mov al,[si] | inc si
				call DoubleBits
				xchg dl,dh
				mov al,[color]
				mov cl,PlaneCount
				do
					xor bx,bx
					test al,01h
					if nz
						or bx,dx
					endif
					test al,10h
					if nz
						not dx
						or bx,dx
						not dx
					endif
					mov [di],bx
					shr al,1
					add di,CharHeight*2
					dec cl
				while nz | wend
				add di,2-CharHeight*2*PlaneCount
			pop cx
			dec ch
		while nz | wend
		add di,CharHeight*2*2
		dec cl
	while nz | wend
ret

MakePatternColor:
	do
		mov ch,CharHeight*PlaneCount
		do
			mov al,[si] | inc si
			call DoubleBits
			xchg dl,dh
			mov [di],dx
			add di,2
			dec ch
		while nz | wend
		dec cl
	while nz | wend
ret


; void ClearScreen();
cseg
ClearScreen_:  public ClearScreen_
	push ax | push cx | push dx | push bx
		xor dx,dx

		mov bx,backup
		mov cx,VVramWidth*VVramHeight/2
		do
			mov [bx],dx
			inc bx | inc bx
		wloop

        mov ax,0c000h
        do
            mov es,ax
            mov bx,0
            mov cx,8000h/2
            do
                mov [es:bx],dx
    			inc bx | inc bx
            wloop
            mov ax,es
            add ah,10h
            cmp ah,0f0h
        while nz | wend


		xor ax,ax 
		mov bx,VVram_
		mov cx,VVramWidth*VVramHeight/2
		do
			mov [bx],ax
			add bx,2
		wloop
	pop bx | pop dx | pop cx | pop ax
ret


cseg
Put1:
; in
;   al: char
;   di: vram address
    push cx | push di
        mov ah,CharSize | mul ah
        add ax,CharRam
        mov si,ax

        mov ax,0c000h | mov es,ax
        do
            mov cl,CharHeight
            do
                mov ax,[si]
                inc si | inc si
                xchg ah,al
                mov [es:di],ax
                mov [es:di+VramWidth],ax
                add di,VramWidth*2
                dec cl
            while ne | wend
            sub di,VramWidth*2*CharHeight
            mov ax,es
            add ah,10h
            mov es,ax
            cmp ah,0f0h
        while ne | wend
    pop di | pop cx
ret


; void Put(word vram, byte c);
cseg
Put_: public Put_
	push ax | push bx | push dx | push si | push di
        push ax
            mov di,ax
            mov al,dl
            call Put1
        pop ax
	pop di | pop si | pop dx | pop bx | pop ax
	inc ax | inc ax
ret


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
	push ax | push cx | push dx | push bx | push si | push di
		mov bx,VVram_
		mov si,Backup
		mov di,Vram+VramRowSize*Top
		mov ch, VVramHeight ; vertical count
		do
			mov cl,VVramWidth
			do 
				mov al,[bx]
				inc bx
				cmp al,[si]
				if ne
					mov [si],al
					push si
						call Put1
					pop si
				endif
				inc di | inc di
				inc si
                inc dx
				dec cl
			while nz | wend
			add di,VramRowSize-VVramWidth*VramStep
            add dx,VramWidth/2-VVramWidth
			dec ch
		while nz | wend
	pop di | pop si | pop bx | pop dx | pop cx | pop ax
ret
